import pythoncom
from win32com.server.exception import COMException
import win32com.server.util
import win32com.client.dynamic
import win32gui
import random
import numpy as np
import statsmodels.api as stat
import statsmodels.tsa.stattools as ts


class PythonUtilities(object):
    _public_methods_=['COINT']

    #
    # Use pythoncom.CreateGuid() 2/1/08
    #               
    _reg_clsid_="{15F32569-9E94-4E9F-1111-95DC9C528A06}"
    _reg_desc_ =   "Coint Implementation in Amibroker"
    _reg_progid_ = "PyCoint"
    _readonly_attrs_ = ['revision']

   # class attributes can be defined and used to transfer values from AFL

    _public_attrs_=['NDepVar','ArrayLen','ProbArray',
                    'X_Open','X_High','X_Low','X_Close',
                    'X_Volume','X_OI','Log']

    Log=""  # Log may be a  string use to pass text to AFL
    
    def COINT(self,InList1,InList2):
        # Cointegration Example
        #
		self.revision="version 1"
		InList1=list(InList1)
		InList2=list(InList2)
		result = stat.OLS(InList2, InList1).fit()
		a = ts.adfuller(result.resid)
		return a[1]
		#adf = a[0]
		#p = a[1]
		#return adf
        
		
if __name__=='__main__':
    print "Registering COM Server "
    import win32com.server.register
    win32com.server.register.UseCommandLine(PythonUtilities)

# uncomment out if you want to unregister com server 

 ##   from win32com.server.register import UnregisterServer
 ##   UnregisterServer(PythonUtilities._reg_clsid_)
 ##   print "Com server unregistered."    

#############################################End Python Code
####################################